#git.d3vopz.net="{ 'version': 'v1alpha1', 'repo' : 'git@gitlab.com:d3vopz-public/images/debian.git', 'file' : '.gitlab-ci.yml' }"
.build-kaniko:
  stage: single-arch-build
  tags:
    - $D3VOPZ_GITLABRUNNER_TAG
  image:
#      name: ${D3VOPZ_DOCKER_REGISTRY}registry.gitlab.com/d3vopz-public/images/kaniko/app:develop
      name: ${D3VOPZ_DOCKER_REGISTRY}gcr.io/kaniko-project/executor:debug
      entrypoint: [""]
  variables:
      D3VOPZ_PLATFORM_amd64: linux/amd64
      D3VOPZ_PLATFORM_arm64v8: linux/arm64/v8
      D3VOPZ_PLATFORM_armv7: linux/arm/v7
      D3VOPZ_UNAME_amd64: x86_64
      D3VOPZ_UNAME_arm64v8: aarch64
      D3VOPZ_UNAME_armv7: armv7l

  only:
    variables: '$CI_COMMIT_REF_NAME != "main" && $CI_COMMIT_REF_NAME != "master"'
  script:
      - |
           echo "-------------------------------------------------------------"
           echo "checking arch: D3VOPZ_ARCH=\"${D3VOPZ_ARCH}\" in D3VOPZ_ARCH_LIST=\"${D3VOPZ_ARCH_LIST}\""
           echo "-------------------------------------------------------------"
           if [[ "$D3VOPZ_ARCH_LIST" == *${D3VOPZ_ARCH}* ]]
           then
             echo "D3VOPZ_ARCH_LIST=\"${D3VOPZ_ARCH_LIST}\" contains D3VOPZ_ARCH=\"${D3VOPZ_ARCH}\". Proceeding with the job.";
           else
             echo "D3VOPZ_ARCH_LIST=\"${D3VOPZ_ARCH_LIST}\" does not contain substring D3VOPZ_ARCH=\"${D3VOPZ_ARCH}\". Skipping the job.";
             exit 0;  # Skip the job if the condition is not met
           fi
           echo "-------------------------------------------------------------"
           echo "building job: ${CI_JOB_NAME}"
           echo "-------------------------------------------------------------"
           d3vopz_kaniko_path=$(which executor)
           echo "ddd: TRACE d3vopz_kaniko_path=\"$d3vopz_kaniko_path\""
           d3vopz_registry_tag=${D3VOPZ_REGISTRY_TAG}
           d3vopz_kaniko_tag=$($d3vopz_kaniko_path version| cut -d':' -f2|xargs)
           echo "ddd: TRACE d3vopz_kaniko_tag=\"$d3vopz_kaniko_tag\""
           echo "running on \"$(uname -m)\""
           env | grep "CI_RUNNER"
           echo "build-base started D3VOPZ_PLATFORM_ARG=\"$D3VOPZ_PLATFORM_ARG\""
           root_cache_dir="/cache"
           if [ -d ${root_cache_dir} ]
           then
            echo "ddd: TRACE root_cache_dir=\"${root_cache_dir}\""
            touch ${root_cache_dir}/${CI_JOB_NAME}
            ls -laR ${root_cache_dir}
           else
            echo "ddd: NOT_FOUND root_cache_dir=\"${root_cache_dir}\""  
           fi
           if [ "0" == "1" ]
           then
            echo "ddd: LIST caching content:"
            find / -name cache
            #echo "ddd: LIST ~"
            #ls -la ~
           fi
           echo "ddd: LIST env D3VOPZ:"
           env | grep D3VOPZ | sort
           if [[ "$CI_COMMIT_REF_NAME" == *"feature"* ]]; then
               echo "ddd: TRACE CI_COMMIT_REF_NAME contains 'feature'"
               featureExt="feature/"
           else
               echo "ddd: TRACE CI_COMMIT_REF_NAME does not contain 'feature'"
               featureExt=""
           fi
           echo "ddd: TRACE featureExt=\"$featureExt\""

           echo "ddd: RULE#063 start"
           if [[ "$CI_COMMIT_REF_NAME" == *"feature"* ]] || [[ "$CI_COMMIT_REF_NAME" == "develop"* ]]; then
               echo "ddd: TRACE CI_COMMIT_REF_NAME contains 'feature' or is 'develop', COMMIT_REF_NAME=\"$CI_COMMIT_REF_NAME\" "
               MY_LOCAL_REGISTRY=$(echo "$D3VOPZ_DOCKER_REGISTRY" | sed 's/\/$//') 
               #MY_AUTH="{\"auths\":{\"$MY_LOCAL_REGISTRY\":{\"auth\":\"$D3VOPZ_DOCKER_REGISTRY_AUTH\"}}}"
               MY_AUTH="{\"auths\":{\"$MY_LOCAL_REGISTRY\":{\"username\":\"$D3VOPZ_DOCKER_REGISTRY_USER\",\"password\":\"$D3VOPZ_DOCKER_REGISTRY_PASSWORD\"}}}"
               MY_LOCAL_REGISTRY="$D3VOPZ_DOCKER_REGISTRY"
               MY_PUSH_REGISTRY="$D3VOPZ_DOCKER_REGISTRY"
               D3VOPZ_TAG_SELF=${d3vopz_registry_tag}-$(echo "${CI_COMMIT_REF_NAME}"|cut -d'/' -f2)
           else
               echo "ddd: TRACE CI_COMMIT_REF_NAME does not contain 'feature' and is not 'develop', COMMIT_REF_NAME=\"$CI_COMMIT_REF_NAME\""
               MY_LOCAL_REGISTRY=""
               MY_PUSH_REGISTRY=""
               MY_AUTH="{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}"
               D3VOPZ_TAG_SELF=$(echo "${CI_COMMIT_REF_NAME}"|cut -d'/' -f2)
               #D3VOPZ_TAG_SELF=${d3vopz_registry_tag}
               if [[ "$CI_COMMIT_REF_NAME" != "${d3vopz_registry_tag}" ]]; then
                  echo "www: MSG \"$CI_COMMIT_REF_NAME \" != \"${d3vopz_registry_tag}\""
               fi
           fi
           echo "ddd: TRACE MY_LOCAL_REGISTRY=\"$MY_LOCAL_REGISTRY\""
           echo "ddd: RULE#063 finish"
           [ ! -d /kaniko/.docker ] && mkdir -p /kaniko/.docker || ls -la /kaniko/.docker
           d3vopz_kaniko_config_file=/kaniko/.docker/config.json
           echo "ddd: CREATE d3vopz_kaniko_config_file=\"$d3vopz_kaniko_config_file\""
           echo "$MY_AUTH" > /kaniko/.docker/config.json
           echo "ddd: RULE#064 start"
           cp /d3vopz-kaniko/kaniko-auth.json /kaniko/.docker/config.json
           echo "ddd: RULE#064 finish"
           [ ! -d /etc/ssl/certs ] && mkdir -p /etc/ssl/certs || ls -la /etc/ssl/certs
           d3vopz_pwd=$PWD
           echo "ddd: TRACE d3vopz_pwd=\"$d3vopz_pwd\""
           cd $d3vopz_pwd
           echo "ddd: TRACE PWD=\"$PWD\""

           for target in ${D3VOPZ_TARGET_LIST}
           do
                echo "-------------------------------------------------------------"
                echo "building target: ${target} for ${D3VOPZ_CUSTOM_PLATFORM}"
                echo "-------------------------------------------------------------"
                D3VOPZ_CUSTOM_PLATFORM_NAME=D3VOPZ_PLATFORM_${D3VOPZ_ARCH}
                echo "ddd: TRACE D3VOPZ_CUSTOM_PLATFORM_NAME=\"${D3VOPZ_CUSTOM_PLATFORM_NAME}\""
                #eval D3VOPZ_CUSTOM_PLATFORM=\$$D3VOPZ_CUSTOM_PLATFORM_NAME
                D3VOPZ_CUSTOM_PLATFORM_TAG=$(echo "-${D3VOPZ_CUSTOM_PLATFORM}" | sed 's/\///g')
                echo "ddd: TRACE D3VOPZ_CUSTOM_PLATFORM_TAG=\"${D3VOPZ_CUSTOM_PLATFORM_TAG}\""
                echo "D3VOPZ_CUSTOM_PLATFORM_NAME=\"${D3VOPZ_CUSTOM_PLATFORM_NAME}\""
                echo "D3VOPZ_CUSTOM_PLATFORM=\"${D3VOPZ_CUSTOM_PLATFORM}\""
                D3VOPZ_CUSTOM_UNAME_NAME=D3VOPZ_UNAME_${D3VOPZ_ARCH}
                eval D3VOPZ_CUSTOM_UNAME=\$$D3VOPZ_CUSTOM_UNAME_NAME
                echo "D3VOPZ_CUSTOM_UNAME_NAME=\"${D3VOPZ_CUSTOM_UNAME_NAME}\""
                echo "D3VOPZ_CUSTOM_UNAME=\"${D3VOPZ_CUSTOM_UNAME}\""
                D3VOPZ_KANIKO_PARAM_CUSTOM_PLATFORM="--custom-platform ${D3VOPZ_CUSTOM_PLATFORM}"
                echo "D3VOPZ_KANIKO_PARAM_CUSTOM_PLATFORM=\"${D3VOPZ_KANIKO_PARAM_CUSTOM_PLATFORM}\""
                MY_IMAGE_NAME=${MY_PUSH_REGISTRY}$CI_REGISTRY_IMAGE/${featureExt}${target}:${D3VOPZ_TAG_SELF}${D3VOPZ_CUSTOM_PLATFORM_TAG}
                MY_DOCKERFILE="${D3VOPZ_DOCKER_DIR}/Dockerfile"
                echo "ddd: TRACE MY_IMAGE_NAME: \"$MY_IMAGE_NAME\""
                echo "ddd: TRACE MY_DOCKERFILE: \"$MY_DOCKERFILE\""
                BUILD_CONTEXT=${D3VOPZ_DOCKER_DIR} 
                echo "ddd: TRACE BUILD_CONTEXT: ${BUILD_CONTEXT}"
                cp /certs/ca-certificates.crt /etc/ssl/certs
                if [ "x${D3VOPZ_BUILD_NOT}" == "xyes" ]
                then
                 echo "iii: D3VOPZ_BUILD_NOT=\"${D3VOPZ_BUILD_NOT}\""
                else
                 echo "ddd: TRACE D3VOPZ_BUILD_NOT=\"${D3VOPZ_BUILD_NOT}\""
                 if [[ "$CI_COMMIT_REF_NAME" == *"feature"* ]] || [[ "$CI_COMMIT_REF_NAME" == "develop"* ]]; then
                     echo "ddd: TRACE CI_COMMIT_REF_NAME contains 'feature' or is 'develop'"
                 else
                     echo "ddd: TRACE CI_COMMIT_REF_NAME does not contain 'feature'and is not 'develop'"
                 fi
                 echo "ddd: TRACE D3VOPZ_CUSTOM_PLATFORM_TAG=\"${D3VOPZ_CUSTOM_PLATFORM_TAG}\""
                 d3vopz_cmd="/$d3vopz_kaniko_path --target=${target} ${D3VOPZ_KANIKO_PARAM_CUSTOM_PLATFORM} \
                 --build-arg D3VOPZ_DOCKER_REGISTRY=$MY_LOCAL_REGISTRY \
                 --build-arg D3VOPZ_TAG_SELF=$D3VOPZ_TAG_SELF \
                 ${D3VOPZ_KANIKO_BUILD_ARG} \
                 --build-arg D3VOPZ_CUSTOM_UNAME=$D3VOPZ_CUSTOM_UNAME \
                 --build-arg D3VOPZ_CUSTOM_PLATFORM_TAG=$D3VOPZ_CUSTOM_PLATFORM_TAG \
                 --build-arg D3VOPZ_CUSTOM_ARCH=$D3VOPZ_ARCH \
                 --context ${BUILD_CONTEXT} --dockerfile $MY_DOCKERFILE --destination $MY_IMAGE_NAME"
                 echo $d3vopz_cmd
                 $d3vopz_cmd
                fi
            done || (echo "eee: MSG Failed to build docker image" && exit 1)
